Pro AnnotationColorSelection_Kill_Notify, ID
;
; This routine is called when the object's top-level
; base is destroyed if the top-level base has no
; parent base.  In general, this routine will not
; need to be modified; allow the DESTRUCT method
; to clean up.
;
Widget_Control, ID, Get_UValue = self
If (N_elements(self) eq 1) then Begin
	If (Obj_Valid(self)) then Begin
		self->Destruct
	EndIf
EndIf
End


Pro AnnotationColorSelection_Event, Event
Widget_Control, Event.Handler, Get_UValue = self
If (N_elements(self) ne 0) then Begin
	If (Obj_Valid(self)) then Begin
		self->Event, Event
	EndIf
EndIf
End


Pro AnnotationColorSelection::Event, Event
EventType = Tag_Names(Event, /Structure)
Case EventType of
	'WIDGET_KILL_REQUEST' : Begin
		Widget_Control, Event.ID, Kill_Notify = ''
		self->Destruct
		Return
		End
	Else :
EndCase
Widget_Control, Event.ID, Get_UValue = UValue
If (N_elements(UValue) eq 0) then Begin
	Return
EndIf
Components = StrTok(UValue, '_', /Extract)
Case Components[0] of
	'MoreColors' : Begin
		CursorColorLabel = Widget_Info(self.TLB, Find_by_UName = 'CursorColorLabel')
		FewerColorsButton = Widget_Info(self.TLB, Find_by_UName = 'FewerColorsButton')
		Widget_Control, FewerColorsButton, /Sensitive
		PaletteWidget = Widget_Info(self.TLB, Find_by_UName = 'PaletteWidget')
		GreenSliderDraw = Widget_Info(self.TLB, Find_by_UName = 'GreenSliderDraw')
		Geom = Widget_Info(PaletteWidget, /Geometry)
		NewSize = Geom.XSize
		If (NewSize lt 256) then Begin
			NewSize = (NewSize * 1.25) < 256
			Widget_Control, PaletteWidget, XSize = NewSize, YSize = NewSize, Update = 0
			Widget_Control, GreenSliderDraw, XSize = NewSize + 10, Update = 0
		EndIf
		Widget_Control, Event.ID, Sensitive = NewSize lt 256, /Update
		End
	'FewerColors' : Begin
		CursorColorLabel = Widget_Info(self.TLB, Find_by_UName = 'CursorColorLabel')
		Widget_Control, CursorColorLabel, Get_Value = WasCursorColor
		MoreColorsButton = Widget_Info(self.TLB, Find_by_UName = 'MoreColorsButton')
		Widget_Control, MoreColorsButton, /Sensitive
		PaletteWidget = Widget_Info(self.TLB, Find_by_UName = 'PaletteWidget')
		GreenSliderDraw = Widget_Info(self.TLB, Find_by_UName = 'GreenSliderDraw')
		Geom = Widget_Info(PaletteWidget, /Geometry)
		NewSize = Geom.XSize
		If (NewSize gt 50) then Begin
			NewSize = (NewSize * .75) > 50
			Widget_Control, PaletteWidget, XSize = NewSize, YSize = NewSize, Update = 0
			Widget_Control, GreenSliderDraw, XSize = NewSize + 10, Update = 0
		EndIf
		Widget_Control, Event.ID, Sensitive = NewSize gt 50, /Update
		End
	'PaletteWidget' : Begin
		Widget_Control, Event.ID, Get_Value = oDrawWindow
		Case Event.Type of
			0 : Begin
				self.WatchingPaletteMouse = 1B
				self->Update_Selected_Color, Event
				End
			1 : Begin
				self.WatchingPaletteMouse = 0B
				End
			2 : Begin
				oDrawWindow->GetProperty, Graphics_Tree = oView
				oSelected = oDrawWindow->Select(oView, $
					[Event.X, Event.Y])
				If (not Obj_Valid(oSelected[0])) then Begin
					Return
				EndIf
				Result = oDrawWindow->PickData(oView, oSelected[0], $
					[Event.X, Event.Y], XYZ)
				XYZ = XYZ > 0
				Color = Reform(Transpose((*self.pImage)[*, XYZ[0], XYZ[1]]))
				CursorColorDraw = Widget_Info(self.TLB, $
					Find_by_UName = 'CursorColorDraw')
				CursorColorLabel = Widget_Info(self.TLB, $
					Find_by_UName = 'CursorColorLabel')
				Widget_Control, CursorColorDraw, Get_Value = oCursorColorWindow
				oCursorColorWindow->GetProperty, Graphics_Tree = oView
				oPolygon = $
					oView->GetByName('CursorColorModel/CursorColorPolygon')
				oPolygon->SetProperty, Color = Color
				oCursorColorWindow->Draw
				Widget_Control, CursorColorLabel, Set_Value = $
					'[' + StrTrim(Long(Color[0]), 2) + ',' + $
					StrTrim(Long(Color[1]), 2) + ',' + $
					StrTrim(Long(Color[2]), 2) + ']'
				If (self.WatchingPaletteMouse) then Begin
					self->Update_Selected_Color, Event
				EndIf
				End
			4 : Begin
				oDrawWindow->Draw
				End
			Else :
		EndCase
		End
	'CursorColorDraw' : Begin
		Widget_Control, Event.ID, Get_Value = oDrawWindow
		oDrawWindow->Draw
		End
	'SelectedColorDraw' : Begin
		Widget_Control, Event.ID, Get_Value = oDrawWindow
		oDrawWindow->Draw
		End
	'GreenSlider' : Begin
		Widget_Control, Event.ID, Get_Value = oDrawWindow
		UpdateColor = 0
		Case Event.Type of
			0 : Begin
				If (Event.Press eq 1) then Begin
					UpdateColor = 1B
					self.WatchingGreenMouse = 1
				EndIf
				End
			1 : Begin
				If (Event.Release eq 1) then Begin
					If (self.WatchingGreenMouse) then Begin
						UpdateColor = 1B
					EndIf
				EndIf
				self.WatchingGreenMouse = 0
				End
			2 : Begin
				If (self.WatchingGreenMouse) then Begin
					UpdateColor = 1B
				EndIf
				End
			4 : Begin
				oDrawWindow->Draw
				End
		EndCase
		If (UpdateColor) then Begin
			Widget_Control, Event.ID, Get_Value = oDrawWindow
			oDrawWindow->GetProperty, Graphics_Tree = oGreenSliderView
			oGreenSliderModel = oGreenSliderView->GetByName( $
				'GreenSliderModel')
			oGreenSliderImage = oGreenSliderModel->GetByName( $
				'GreenSliderImageModel/GreenSliderImage')
			oGreenCursorModel = oGreenSliderModel->GetByName( $
				'GreenCursorModel')
			R = oDrawWindow->Pickdata(oGreenSliderView, oGreenSliderModel, $
				[Event.X, Event.Y], XYZ)
			X = (XYZ[0] > 3) < 258
			Color = X - 3
			oGreenCursorModel->Reset
			oGreenCursorModel->Translate, X + 2, 0, 0
			oGreenCursorPolygon = oGreenCursorModel->GetByName('GreenCursorPolygon')
			oGreenCursorPolygon->SetProperty, Color = [0, Color, 0]
			oDrawWindow->Draw
			(*self.pImage)[1, *, *] = Color
			PaletteWidget = Widget_Info(self.TLB, Find_by_UName = 'PaletteWidget')
			Widget_Control, PaletteWidget, Get_Value = oPaletteWindow
			oPaletteWindow->GetProperty, Graphics_Tree = oView
			oImage = oView->GetByName('PaletteModel/PaletteImage')
			oImage->SetProperty, Data = *self.pImage
			oPaletteWindow->Draw
		EndIf
		End
	Else :
EndCase
End
