Function AnnotationColorSelection::Init, Parent, $
	CurrentColor = CurrentColor, $
	Callback = Callback, $
	CB_Data = CB_Data, VisibleStrings = VisibleStrings, $
	_Extra = Extra
Catch, ErrorNumber
If (ErrorNumber ne 0) then Begin
	Catch, /Cancel
	Help, /Last_Message
	self->Destruct
	Return, 0
EndIf
self.pVisibleStrings = Ptr_New ({ $
	ColorBarTitle	: ' ', $
	MoreColorsLabel	: 'More Colors', $
	FewerColorsLabel: 'Fewer Colors' $
	})
self->Update_Visible_Strings, VisibleStrings
If (N_elements(Parent) eq 1) then Begin
	self.TLB = Widget_Base(Parent, /Row, $
		UName = 'AnnotationColorSelectionBase', _Extra = Extra)
EndIf Else Begin
	self.TLB = Widget_Base(_Extra = Extra, $
		Title = (*self.pVisibleStrings).ColorBarTitle, $
		TLB_Frame_Attr = 11, Frame = 1, /TLB_Kill_Request_Events, $
		/Base_Align_Center, UName = 'AnnotationColorSelectionBase', $
		/Row)
EndElse
If (N_elements(Callback) eq 1) then Begin
	self.Callback = Callback
EndIf
If (N_elements(CB_Data) ne 0) then Begin
	self.pCB_Data = Ptr_New(CB_Data)
EndIf
If (N_elements(CurrentColor) eq 3) then Begin
	Color = CurrentColor
EndIf Else Begin
	Color = [0, 0, 0]
EndElse
SwatchSize = 30
LeftBase = Widget_Base(self.TLB, UName = 'LeftBase', /Column)
NColorsBase = Widget_Base(LeftBase, UName = 'NColorsBase', /Align_Top, /Column)
MoreColorsButton = Widget_Button(LeftBase, UName = 'MoreColorsButton', $
	Value = (*self.pVisibleStrings).MoreColorsLabel, $
	UValue = 'MoreColors', /Dynamic_Resize)
FewerColorsButton = Widget_Button(LeftBase, UName = 'FewerColorsButton', $
	Value = (*self.pVisibleStrings).FewerColorsLabel, $
	UValue = 'FewerColors', /Dynamic_Resize)
FCBGeom = Widget_Info(FewerColorsButton, /Geometry)

ColorSwatchBase = Widget_Base(LeftBase, UName = 'ColorSwatchBase', $
	/Align_Center, /Column, /Base_Align_Center, /Frame)
CursorColorBase = Widget_Base(ColorSwatchBase, UName = 'CursorColorBase', $
	/Column, /Align_Center, /Base_Align_Center, /Frame)
CursorColorDraw = Widget_Draw(CursorColorBase, $
	UName = 'CursorColorDraw', Renderer = 1, /Expose_Events, $
	Retain = 0, Graphics_Level = 2, XSize = SwatchSize, YSize = SwatchSize, $
	UValue = 'CursorColorDraw', /Align_Center)
CursorColorLabel = Widget_Label(CursorColorBase, $
	/Align_Center, Value = '8*[255,255,255]*8', $
	UName = 'CursorColorLabel', /Dynamic)
Geom = Widget_Info(CursorColorBase, /Geom)
Widget_Control, CursorColorBase, Set_UValue = Geom.Scr_XSize
Widget_Control, CursorColorBase, Scr_XSize = Geom.Scr_XSize
SelectedColorBase = Widget_Base(ColorSwatchBase, UName = 'SelectedColorBase', $
	/Column, /Align_Center, /Base_Align_Center, /Frame)
Widget_Control, SelectedColorBase, Set_UValue = Geom.Scr_XSize
Widget_Control, SelectedColorBase, Scr_XSize = Geom.Scr_XSize
SelectedColorDraw = Widget_Draw(SelectedColorBase, $
	UName = 'SelectedColorDraw', Renderer = 1, /Expose_Events, $
	Retain = 0, Graphics_Level = 2, XSize = SwatchSize, YSize = SwatchSize, $
	UValue = 'SelectedColorDraw', /Align_Center)
SelectedColorLabel = Widget_Label(SelectedColorBase, $
	/Align_Center, Value = '8*[255,255,255]*8', $
	UName = 'SelectedColorLabel', /Dynamic)

RightBase = Widget_Base(self.TLB, UName = 'RightBase', /Column)
PaletteBase = Widget_Base(RightBase, UName = 'PaletteBase', /Column, $
	/Align_Center)

Scale = .5

PaletteDrawWidget = Widget_Draw(PaletteBase, $
	UName = 'PaletteWidget', Renderer = 1, UValue = 'PaletteWidget', $
	/Button_Events, /Expose_Events, /Motion_Events, Graphics_Level = 2, $
	XSize = 256*Scale, YSize = 256*Scale, Retain = 0, Frame = 1)
GreenSliderBase = Widget_Base(RightBase, UName = 'GreenSliderBase', $
	/Column, Frame = 1)
GreenSliderDraw = Widget_Draw(GreenSliderBase, XSize = 256*Scale + 10., $
	YSize = 20, UName = 'GreenSliderDraw', $
	UValue = 'GreenSlider', /Button_Events, /Motion_Events, $
	Graphics_Level = 2, /Expose_Events, /Align_Center, Renderer = 1, $
	Retain = 0)

self.oContainer = Obj_New('IDL_Container')
oPaletteView = Obj_New('IDLgrView', Viewplane_Rect = [0, 0, 256, 256], $
	Name = 'PaletteView')
self.oContainer->Add, oPaletteView
oPaletteModel = Obj_New('IDLgrModel', Name = 'PaletteModel')
oPaletteView->Add, oPaletteModel
N = 256
PaletteImage = BytArr(3, N, N)
For R = 0, N - 1 Do Begin
	For B = 0, N - 1 Do Begin
		PaletteImage[0, R, B] = R
		PaletteImage[1, R, B] = 128B
		PaletteImage[2, R, B] = B
	EndFor
EndFor
self.pImage = Ptr_New(PaletteImage, /No_Copy)
oImage = Obj_New('IDLgrImage', Name = 'PaletteImage', *self.pImage)
oPaletteModel->Add, oImage
;oPaletteModel->Scale, Scale, Scale, 1.

X = [0, 1, 1, 0, 0]*SwatchSize
Y = Shift(X, 1)

oSelectedColorView = Obj_New('IDLgrView', $
	Viewplane_Rect = [0, 0, SwatchSize, SwatchSize], Name = 'SelectedColorView')
self.oContainer->Add, oSelectedColorView
oSelectedColorModel = Obj_New('IDLgrModel', Name = 'SelectedColorModel')
oSelectedColorView->Add, oSelectedColorModel
oPolygon = Obj_New('IDLgrPolygon', X, Y, Style = 2, $
	Name = 'SelectedColorPolygon', Color = Color)
oSelectedColorModel->Add, oPolygon

oCursorColorView = Obj_New('IDLgrView', Name = 'CursorColorView', $
	Viewplane_Rect = [0, 0, SwatchSize, SwatchSize])
self.oContainer->Add, oCursorColorView
oCursorColorModel = Obj_New('IDLgrModel', Name = 'CursorColorModel')
oCursorColorView->Add, oCursorColorModel
;Color = [255, 128, 255]
oPolygon = Obj_New('IDLgrPolygon', X, Y, Style = 2, $
	Name = 'CursorColorPolygon')
oCursorColorModel->Add, oPolygon

Colors = Widget_Info(self.TLB, /System_Colors)
If (StrUpCase(!version.os_family) eq 'MACOS') then Begin
	Colors.Face_3D = [200, 200, 200]
EndIf
oGreenSliderView = Obj_New('IDLgrView', Name = 'GreenSliderView', $
	Viewplane_Rect = [0, 0, 266, 20], Color = Colors.Face_3D)
self.oContainer->Add, oGreenSliderView
oGreenSliderModel = Obj_New('IDLgrModel', Name = 'GreenSliderModel')
oGreenSliderView->Add, oGreenSliderModel
oGreenSliderImageModel = Obj_New('IDLgrModel', $
	Name = 'GreenSliderImageModel')
oGreenSliderModel->Add, oGreenSliderImageModel
GreenImage = BytArr(3, 256, 12)
GreenImage[1, *, *] = Bindgen(256)#(BytArr(12) + 1B)
oGreenSliderImage = Obj_New('IDLgrImage', GreenImage, $
	Name = 'GreenSliderImage')
oGreenSliderImageModel->Add, oGreenSliderImage
oGreenSliderImageModel->Translate, 5, 7, 0
oGreenCursorModel = Obj_New('IDLgrModel', Name = 'GreenCursorModel')
oGreenSliderModel->Add, oGreenCursorModel
CaratX = [-5, 0, 5, -5]
CaratY = [0, 5, 0, 0]
Z = FltArr(4) + .1
oGreenCursorPolygon = Obj_New('IDLgrPolygon', CaratX, CaratY, $
	Style = 2, Color = [0, 192, 0], Name = 'GreenCursorPolygon')
oGreenCursorModel->Add, oGreenCursorPolygon
oGreenCursorPolyline = Obj_New('IDLgrPolyline', CaratX, CaratY, Z, $
	Color = [0, 0, 0], Name = 'GreenCursorPolyline')
oGreenCursorModel->Add, oGreenCursorPolyline
oGreenCursorModel->Translate, 195, 0, 0

Widget_Control, self.TLB, Set_UValue = self, $
	Kill_Notify = 'AnnotationColorSelection_Kill_Notify'
Widget_Control, CursorColorLabel, Set_Value = ''
Widget_Control, SelectedColorLabel, $
	Set_Value = '[' + StrTrim(Long(Color[0]), 2) + ',' + $
		StrTrim(Long(Color[1]), 2) + ',' + $
		StrTrim(Long(Color[2]), 2) + ']'
Widget_Control, self.TLB, /Realize
Widget_Control, PaletteDrawWidget, Get_Value = oDrawWindow
oDrawWindow->SetProperty, Graphics_Tree = oPaletteView
oDrawWindow->SetCurrentCursor, 'ARROW'
Widget_Control, CursorColorDraw, Get_Value = oDrawWindow
oDrawWindow->SetProperty, Graphics_Tree = oCursorColorView
oDrawWindow->SetCurrentCursor, 'ARROW'
Widget_Control, SelectedColorDraw, Get_Value = oDrawWindow
oDrawWindow->SetProperty, Graphics_Tree = oSelectedColorView
oDrawWindow->SetCurrentCursor, 'ARROW'
Widget_Control, GreenSliderDraw, Get_Value = oDrawWindow
oDrawWindow->SetProperty, Graphics_Tree = oGreenSliderView
oDrawWindow->SetCurrentCursor, 'ARROW'
Resolve_Routine, 'AnnotationColorSelection::Event'
XManager, 'AnnotationColorSelection', self.TLB, Event_Handler = $
	'AnnotationColorSelection_Event', /No_Block, /Just_Reg
Return, 1
End